// Mayce wrapper
// devilducky@gmx.net

#include <ddraw.h>

#define MCOLORKEY (0xf81F)

typedef LPDIRECTDRAWSURFACE7	MSurface;

class MImage
{
	public:
	MSurface Surface;
	int Width, Height;
	
	MImage ();
	MImage (LPCSTR strFile);
	MImage (int iNewWidth, int iNewHeight);
	~MImage ();
	void Create ();
	void Destroy ();
	void New (int iNewWidth, int iNewHeight);
	void Load (LPCSTR strFile);
	void Blit (int posX, int posY, MImage &mimSrc, int posXSrc, int posYSrc, int lenX, int lenY);
	void Clear (int posX0 = -1, int posY0 = -1, int posX1 = -1, int posY1 = -1);
	MImage& operator =(MImage& mimOp);
	void BlitTransparent (int posXDest, int posYDest, MImage &mimSrc);
	inline void BlitComplete (int posXDest, int posYDest, MImage &mimSrc)
	{
		Blit( posXDest, posYDest, mimSrc, 0, 0, mimSrc.Width, mimSrc.Height);
	}
	COLORREF GetPoint (int posX, int posY);
};
extern MImage Screen;
extern MImage ScreenBack;

class MDraw {
	public:
	
	LPDIRECTDRAW7 lpDD;
	int Width, Height, Colordepth;
	bool bFix;

	//functions
	void Open ();
	void Close ();
	void VideoMode (int newWidth,int newHeight,int newColordepth);
};
extern MDraw *Draw;

class MImageArray {
	public:

	MImage *bufDib;
	MIndex numDib;

	MImageArray();
	~MImageArray();
	MIndex GetNextFree();
	MIndex Add (LPCSTR strPath);
	MIndex Add (MImage& mimAdd);
	void Del (MIndex idxImage);
	void Create ();
	void Destroy ();
	MImage& operator [] (MIndex idxImage);
};

#ifdef NDEBUG
	#define CheckDD(a,b) (a)
#else
	void CheckDD (HRESULT hrFunc, LPCSTR strText = "");
#endif