// Mayce toolkit
// devilducky@gmx.net

#include "tools.h"
#include <conio.h>
#include "filetools.h"

// FILE FINDER CLASS

FindFile::FindFile ()
{
	Create ();
}
FindFile::~FindFile ()
{
	Destroy ();
}
void FindFile::Create ()
{
	hFindFile = INVALID_HANDLE_VALUE;
	memset (strFile, 0, sizeof(strFile));
}
void FindFile::Destroy ()
{
	if (hFindFile != INVALID_HANDLE_VALUE)
		FindClose (hFindFile);

	Create ();
}
bool FindFile::Find (LPCSTR strMask)
{
	WIN32_FIND_DATA dataFind;

	if (hFindFile == INVALID_HANDLE_VALUE)
	{
		hFindFile = FindFirstFile (strMask, &dataFind);

		if (hFindFile != INVALID_HANDLE_VALUE)
		{
			strcpy (strFile, dataFind.cFileName);
			return true;
		}
		else
		{
			memset (strFile, 0, sizeof(strFile));
			return false;
		}
	}
	else
	{
		if (FindNextFile (hFindFile, &dataFind))
		{
			strcpy (strFile, dataFind.cFileName);
			return true;
		}
		else
		{
			memset (strFile, 0, sizeof(strFile));
			hFindFile = INVALID_HANDLE_VALUE;
			return false;
		}
	}
}

// TEXTFILE CLASS

TextFile::TextFile ()
{
	Create ();
}
TextFile::TextFile (LPCSTR strFile)
{
	Create ();
	Open (strFile);
}
TextFile::~TextFile ()
{
	Destroy ();
}

void TextFile::Create ()
{
	fileText = NULL;
	memset (strBuffer, 0, sizeof(strBuffer));
}

void TextFile::Destroy ()
{
	Close ();
}

void TextFile::Open (LPCSTR strFile)
{
	Check0 (fileText = fopen (strFile, "r"), "I/O textfile error");
}

void TextFile::Close ()
{
	if (fileText)
		fclose (fileText);

	Create ();
}

void TextFile::Reset ()
{
	Assert0 (fileText, "TEXTFILE reset error");
	
	fseek (fileText, 0, SEEK_SET);
}

char *TextFile::GetLine (LPSTR strLineBuffer)
{
	Assert0 (fileText, "TEXTFILE getline error");

	// get line, eof -> NULL
	if (fgets (strBuffer, 256, fileText) == NULL)
		return NULL;
	
	// remove '\n'
	if (strlen(strBuffer) && strBuffer[ strlen(strBuffer) - 1 ] == '\n')
		strBuffer[ strlen(strBuffer) - 1 ] = 0;

	// copy to line buffer
	if (strLineBuffer)
	{
		strcpy (strLineBuffer, strBuffer);
		return strLineBuffer;
	}
	return strBuffer;
}

char *TextFile::FindSetting (LPCSTR strSetting, LPSTR strLineBuffer, char chSeperator)
{
	char strNormSetting [256];
	char strNormLine [256];

	strcpy (strNormSetting, strSetting);
	RemoveSpace (strNormSetting);

	Reset ();
	
	// does line exist ?
	while(GetLine())
	{
		// no seperator ?
		if (!chSeperator)
		{
			// get a normalized setting
			strcpy (strNormLine, strBuffer);
			RemoveSpace (strNormLine);
			
			if (!_stricmp (strNormLine, strNormSetting))
				return (char *) strSetting;
		}
		// just seeking
		else if (chSeperator == FIND_CUT)
		{
			// cut @ space
			char strCutSetting[256];
			strcpy (strCutSetting, strSetting);
			Trim (strCutSetting);
			if (strchr (strCutSetting,' '))
				strchr (strCutSetting,' ') [0] = '\0';
			
			char strCutLine[256];
			strcpy (strCutLine, strBuffer);
			Trim (strCutLine);
			if (strchr (strCutLine,' '))
				strchr (strCutLine,' ') [0] = '\0';

			if (!_stricmp (strCutLine, strCutSetting))
			{
				// copy to line buffer
				if (strLineBuffer)
				{
					strcpy (strLineBuffer, strBuffer);
					return strLineBuffer;
				}
				return strBuffer;
			}
		}
		// seperator in there ?
		else if (strchr (strBuffer, chSeperator))
		{
			// get a normalized setting
			strcpy (strNormLine, strBuffer);
			strchr (strNormLine, chSeperator) [0] = 0;
			RemoveSpace (strNormLine);

			// identical, kill setting from buffer and exit loop
			if (!_stricmp (strNormLine, strNormSetting))
			{
				memmove (strBuffer, strchr(strBuffer, chSeperator) + 1, strlen (strchr (strBuffer, chSeperator)));
				
				// remove ' ' at stringfront
				while (strBuffer[0] == ' ')
					memmove (strBuffer, &strBuffer[1], strlen(strBuffer));

				// copy to line buffer
				if (strLineBuffer)
				{
					strcpy (strLineBuffer, strBuffer);
					return strLineBuffer;
				}
				return strBuffer;			
			}
			
		}
	}

	return NULL;
}
long TextFile::GetPos ()
{
	Assert0 (fileText, "TEXTFILE getpos error");
	
	return ftell (fileText);
}
void TextFile::SetPos (long lPosNew)
{
	Assert0 (fileText, "TEXTFILE setpos error");
	
	fseek (fileText, lPosNew, SEEK_SET);
}