// Abiventure app Mgr
// devilducky@gmx.net

#include "tools.h"
#include "filetools.h"
#include "graphtool.h"
#include "appmgr.h"
#include "winfunc.h"

MSpeechUnit::MSpeechUnit (MFont *fntNew, long lID)
{
	Create (fntNew, lID);
}
MSpeechUnit::~MSpeechUnit ()
{
	Destroy ();
}
void MSpeechUnit::Create (MFont *fntNew, long lID)
{
	strTextBuffer[0] = '\0';
	strLineBuffer[0] = '\0';
	timeTextRemain = 0;
	bTalkNotify = false;
	lTalkerID = lID;
	Font = fntNew;
	fWaitFactor = 1.0f;
}

void MSpeechUnit::Destroy ()
{
}

void MSpeechUnit::Cancel ()
{
	strTextBuffer[0] = '\0';
	timeTextRemain = 0;
	bTalkNotify = false;
}
void MSpeechUnit::Skip ()
{
	timeTextRemain = 0;
}

void MSpeechUnit::Set (int posXnew, int posYnew)
{
	posStatic.x = posXnew;
	posStatic.y = posYnew;
}

void MSpeechUnit::Add (LPCSTR strText, bool bEvent, long lID)
{
	if (strText && strText[0])
	{
		lSendID = lID;
		
		if (strTextBuffer[0])
			strcat (strTextBuffer, "#");
		strcat (strTextBuffer, strText);
		if (bEvent)
			bTalkNotify = true;
	}
}

void MSpeechUnit::Render (MImage *imgDest, DWORD timeDelta, POINT *posTalker)
{
	POINT *posOut = posTalker ? posTalker : &posStatic;

	if (timeTextRemain > 0)
	{
		timeTextRemain -= timeDelta;
	}
	else
	{
		if (!strTextBuffer[0])
		{
			if (bTalkNotify)
			{
				bTalkNotify = false;
				App->Events (CM_TALKDONE, (WORD)lSendID, lTalkerID);
			}
			return;
		}
		timeTextRemain = (long)((float)App->timeTextRemain * fWaitFactor);
		// new line
		int iPos = 0;

		for (MIndex idxChar = 0; idxChar <= (MIndex)strlen(strTextBuffer); idxChar++)
		{
			if (strTextBuffer[idxChar] == '#' && !iPos)
			{
				strLineBuffer[idxChar] = '\0';
				iPos = idxChar;
			}
			else
			{
				if (iPos)
					strTextBuffer[idxChar - iPos - 1] = strTextBuffer[idxChar];
				else
					strLineBuffer[idxChar] = strTextBuffer[idxChar];
			}
		}
		if (!iPos)
		{
			// text buffer empty
			strTextBuffer [0] = '\0';
		}
	}

	if (!strLineBuffer[0])
		return;
	
	char strLine[256];
	char *strPos = strLineBuffer;
	int posMY = -20;
	
	while (strchr (strPos, '%'))
	{
		strcpy (strLine, strPos);
		strchr (strLine, '%') [0] = '\0';
		
		Font->PrintCenterText (posOut->x, posOut->y + posMY, strLine, imgDest);
		posMY += Font->iRowHeight;

		strPos = strchr (strPos, '%') + 1;
	}
	
	Font->PrintCenterText (posOut->x, posOut->y + posMY, strPos, imgDest);
}

bool MSpeechUnit::isEmpty ()
{
	return (strTextBuffer[0] == '\0');
}