// Mayce toolkit
// devilducky@gmx.net

#include "tools.h"
#include "winreg.h"
#include <stdlib.h>
#include "winfunc.h"
#include "mmsystem.h"

#define MREG_KEY "Software\\Ducky\\Mayce"

FILE *fileLog;
char *strGlobalBuffer; 

void MToolsOpen () 
{
	// open a logfile
	fileLog = fopen ("c:\\log.txt", "w");
	
	fputs ("Abiventure <Mayce2d> Log\r\n" ,fileLog);
}

void MToolsClose ()
{
	fclose (fileLog);
	fileLog = NULL;

	delete [] strGlobalBuffer;
}

void LogA (LPCSTR strLog)
{
	if (strLog && fileLog)
	{
		fputs( strLog ,fileLog);
		fputs( "\r\n" ,fileLog);
	}
}

void Error( LPCSTR strMes) 
{
	Log( strMes);
	exit(1);
}

#ifndef NDEBUG
long GetRegLong( LPCSTR strRegSubKey)
{
	DWORD lenBuffer, Buffer;
	HKEY keySub;

	RegOpenKeyEx( HKEY_LOCAL_MACHINE, MREG_KEY, 0, KEY_READ, &keySub);
	
	lenBuffer = 4;
	Check1( RegQueryValueEx( keySub, strRegSubKey, NULL, NULL, (LPBYTE) &Buffer, &lenBuffer), "RegQuery failed");
		
	RegCloseKey( keySub);
	
	return Buffer;
}

LPSTR GetRegString( LPCSTR strRegSubKey, LPSTR strBuffer, long lenBuffer)
{
	HKEY keySub;

	RegOpenKeyEx( HKEY_LOCAL_MACHINE, MREG_KEY, 0, KEY_READ, &keySub);
	
	Check1( RegQueryValueEx( keySub, strRegSubKey, NULL, NULL, (LPBYTE) strBuffer, (LPDWORD) &lenBuffer), "RegQuery failed");
	
	RegCloseKey( keySub);
	
	return strBuffer;
}

GUID *GetRegGUID( LPCSTR strRegSubKey, GUID *guidBuffer)
{
	DWORD lenBuffer, dwBuffer;
	HKEY keySub;
	char strPath[100] = { MREG_KEY };

	strcat( strPath, strRegSubKey);

	RegOpenKeyEx( HKEY_LOCAL_MACHINE, strPath, 0, KEY_READ, &keySub);
	
	lenBuffer = 4;
	Check1( RegQueryValueEx( keySub, "Data1", NULL, NULL, (LPBYTE) &guidBuffer->Data1, &lenBuffer), "RegQuery failed");

	if( guidBuffer->Data1 == 0xFFFFFFFF)
	{
		// standart device
		RegCloseKey( keySub);
		return NULL;
	}

	Check1( RegQueryValueEx( keySub, "Data2", NULL, NULL, (LPBYTE) &dwBuffer, &lenBuffer), "RegQuery failed");
	guidBuffer->Data2 = (WORD) dwBuffer;

	Check1( RegQueryValueEx( keySub, "Data3", NULL, NULL, (LPBYTE) &dwBuffer, &lenBuffer), "RegQuery failed");
	guidBuffer->Data3 = (WORD) dwBuffer;
	
	lenBuffer = 8;
	Check1( RegQueryValueEx( keySub, "Data4", NULL, NULL, (LPBYTE) guidBuffer->Data4, &lenBuffer), "RegQuery failed");
	
	RegCloseKey( keySub);
	return guidBuffer;
}
#endif

char *RemoveSpace (char *strString)
{
	for (MIndex idxChar = 0; idxChar < (MIndex) strlen (strString); idxChar++)
	{
		if (strString[idxChar] == ' ' || strString[idxChar] == '\t')
		{
			// delete space
			memmove (&strString[idxChar], &strString[idxChar + 1], strlen(strString) - idxChar);
			idxChar--;
		}
	}
	return strString;
}

void SplitVec (char *strData, POINT *posXY, int *posZ)
{
	int iX, iY;
	SplitVec (strData, &iX, &iY, posZ);
	posXY->x = iX;
	posXY->y = iY;
}

void SplitVec (char *strData, int *posX, int *posY, int *posZ)
{
	char strTemp [256];
	
	if (!strData)
		return;

	strcpy (strTemp, strData);
	strchr (strTemp, ',') [0] = 0;
	*posX = atoi (strTemp);

	strcpy (strTemp, strchr (strData, ',') + 1);

	if (posZ && strchr (strTemp, ','))
	{
		strchr (strTemp, ',') [0] = 0;
		
		*posY = atoi (strTemp);

		*posZ = atoi (strchr (strchr (strData, ',') + 1, ',') + 1);
	}
	else
	{
		*posY = atoi (strchr (strData, ',') + 1);
	}
}

void SplitRect (char *strData, RECT *rectDest)
{
	char strTemp [256];
	
	strcpy (strTemp, strData);
	strchr (strTemp, ',') [0] = 0;
	rectDest->left = atoi (strTemp);

	strcpy (strTemp, strchr (strData, ',') + 1);
	strchr (strTemp, ',') [0] = 0;
	rectDest->top = atoi (strTemp);
	
	strcpy (strTemp, strchr (strchr (strData, ',') + 1, ',') + 1);
	strchr (strTemp, ',') [0] = 0;
	rectDest->right = atoi (strTemp);
	
	rectDest->bottom = atoi (strchr (strchr (strchr (strData, ',') + 1, ',') + 1, ',') + 1);
}

char *Trim (char *strData)
{
	while (strData [0] ==' ' || strData [0] == '\t')
		memmove (strData, &strData[1], strlen(strData));

	while (strData [strlen(strData) - 1] == ' ' || strData [strlen(strData) - 1] == '\t')
		strData[strlen(strData) - 1] = '\0';

	return strData;
}

void CDCommand (LPCSTR strCmd)
{
	mciSendString("open cdaudio", NULL, 0, NULL);
	mciSendString("set cdaudio time format tmsf", NULL, 0, NULL);
	mciSendString(strCmd, NULL, 0, NULL);
	mciSendString("close cdaudio", NULL, 0, NULL); 
}
