// Mayce toolkit
// devilducky@gmx.net

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

// Logging & Errors
extern FILE *fileLog;
void Error( LPCSTR strMes);
void LogA( LPCSTR strMes);

#ifndef NDEBUG
  #define Check0(a,b) {if(!(a)) Error(b);}
  #define Check1(a,b) {if(a) Error(b);}
  #define Assert0(a,b) {if(!(a)) Error(b);}
  #define Log(a) LogA(a)
#else
  #define Check0(a,b) a
  #define Check1(a,b) a
  #define Assert0(a,b) {}
  #define Log(a) {}
#endif
#define LogStr(a,b) {char buf[80];sprintf(buf,"%s%s",a,b);Log(buf);}
#define LogVec(a,b) {char buf[80];sprintf(buf,"%s%g/%g/%g",a,(b).x,(b).y,(b).z);Log(buf);}
#define LogInt(a,b) {char buf[80];sprintf(buf,"%s%d",a,b);Log(buf);}
#define LogLong(a,b) {char buf[80];sprintf(buf,"%s%ld",a,b);Log(buf);}
#define LogDw(a,b) {char buf[80];sprintf(buf,"%s%lu",a,b);Log(buf);}
#define LogHex(a,b) {char buf[80];sprintf(buf,"%s%lX",a,b);Log(buf);}
#define LogFloat(a,b) {char buf[80];sprintf(buf,"%s%g",a,b);Log(buf);}
#define Log3Float(a,b,c,d) {char buf[80];sprintf(buf,"%s%g/%g/%g",a,b,c,d);Log(buf);}
#define Log3Int(a,b,c,d) {char buf[80];sprintf(buf,"%s%d/%d/%d",a,b,c,d);Log(buf);}
#define Log2Float(a,b,c) {char buf[80];sprintf(buf,"%s%g/%g",a,b,c);Log(buf);}
#define LogOK(a,b) {char buf[80],ok[5]="OK",err[5]="ERR";sprintf(buf,"%s%s",a,(b==D3D_OK) ? ok : err);Log(buf);};

// Math
#define sqr(a) ((a)*(a))
#define SwapInt(a,b) {int c=a;a=b;b=c;}
#define SwapBool(a,b) {bool c=a;a=b;b=c;}
#define rnd(a) ((long)rand()*(long)(a)/(long)(RAND_MAX+1))

// I/O
#define SafeRead(h,b,n) {DWORD d;ReadFile(h,b,n,&(d),NULL);if((d)!=(n)) Mayce->Error("I/O Error");}
void CDCommand (LPCSTR strCmd);
#define WriteString(h,a) {int l = ((a)==NULL) ? 0:strlen(a)+1; fwrite(&l,1,sizeof(int),h); if (l) fwrite(a,l,1,h);}
#define ReadString(h,a) {int l; fread(&l,1,sizeof(int),h); if (l) fread(a,l,1,h);}
#define ReadDynamicString(h,a) {int l; fread(&l,1,sizeof(int),h); if (l) {if (a) delete (a); a=new char [l];fread(a,l,1,h);}}
#define WriteData(h,a) {fwrite(&a,1,sizeof(a),h);}
#define ReadData(h,a) {fread(&a,1,sizeof(a),h);}

// general
void MToolsOpen ();
void MToolsClose ();

// types
typedef int MIndex;

// string
#define istrchr(a,b) ((int)(((DWORD)(a))-((DWORD)(strchr(a,b)))))
char *RemoveSpace (char *strString);
void SplitRect (char *strData, RECT *rectDest);
void SplitVec (char *strData, int *posX, int *posY, int *posZ = NULL);
void SplitVec (char *strData, POINT *posXY, int *posZ = NULL);
char *Trim (char *strData);

// Registry
#ifndef NDEBUG
long GetRegLong( LPCSTR strRegSubKey);
LPSTR GetRegString( LPCSTR strRegSubKey, LPSTR strBuffer, long lenBuffer);
GUID *GetRegGUID( LPCSTR strRegSubKey, GUID *guidBuffer);
#endif