// Abiventure app Mgr
// devilducky@gmx.net

#include "tools.h"
#include "filetools.h"
#include "graphtool.h"
#include "appmgr.h"
#include "winfunc.h"
#include "mmsystem.h"
#include <iostream>

#define CD_RANDOMTRACKS 8

void MApplication::Open ()
{
	// set video mode
	Draw->VideoMode (800, 600, 16);

	timeTextRemain = 3500;
	CDCommand ("play cdaudio from 2 to 3");
	srand ((unsigned) timeGetTime ());

	Screen.Clear ();
	
	MImage imgLoad;

	bool bSkip = false;
	DWORD timeWait = timeGetTime () + 4000;
	while (timeWait > timeGetTime () && !bSkip)
		if (GetAsyncKeyState (VK_ESCAPE) )
			bSkip = true;
	
	if (!bSkip)
	{
		imgLoad.Load ("intro\\intro3.bmp");
		Screen.BlitComplete (0, 0, imgLoad);
		timeWait = timeGetTime () + 10000;
		while (timeWait > timeGetTime () && !bSkip)
			if (GetAsyncKeyState (VK_ESCAPE) )
				bSkip = true;
	}
	
	if (!bSkip)
	{
		imgLoad.Load ("intro\\intro4.bmp");
		Screen.BlitComplete (0, 0, imgLoad);
		timeWait = timeGetTime () + 10000;
		while (timeWait > timeGetTime () && !bSkip)
			if (GetAsyncKeyState (VK_ESCAPE) )
				bSkip = true;
	}
	if (!bSkip)
	{
		imgLoad.Load ("intro\\intro5.bmp");
		Screen.BlitComplete (0, 0, imgLoad);
		timeWait = timeGetTime () + 10000;
		while (timeWait > timeGetTime () && !bSkip)
			if (GetAsyncKeyState (VK_ESCAPE) )
				bSkip = true;
	}
	if (!bSkip)
	{
		imgLoad.Load ("intro\\intro1.bmp");
		Screen.BlitComplete (0, 0, imgLoad);
		timeWait = timeGetTime () + 10000;
		while (timeWait > timeGetTime () && !bSkip)
			if (GetAsyncKeyState (VK_ESCAPE) )
				bSkip = true;
	}
	if (!bSkip)
	{
		imgLoad.Load ("intro\\intro2.bmp");
		Screen.BlitComplete (0, 0, imgLoad);
		timeWait = timeGetTime () + 10000;
		while (timeWait > timeGetTime () && !bSkip)
			if (GetAsyncKeyState (VK_ESCAPE) )
				bSkip = true;
	}
	
	// init dialog
	CurDialog = new MDialog;
	
	// init registry
	Registry = new MRegistry;

	// count fonts
	numFonts = 0;
	FindFile findFont;
	while (findFont.Find ("fonts\\*.bmp"))
		numFonts++;
	
	// alloc mem & load fonts
	if (numFonts)
		Font = new MFont[numFonts];

	findFont.Destroy ();

	for (MIndex idxFont = 0; idxFont < numFonts; idxFont++)
	{
		char strPath[256];
		char strName[256];
		findFont.Find ("fonts\\*.bmp");
		
		// name & create fonts
		sprintf (strPath, "fonts\\%s", findFont.strFile);
		strcpy (strName, findFont.strFile);
		strchr (strName, '.') [0] = '\0';

		Font[idxFont].Open (strPath, strName);
	}
	
	// create standart actor
	CurActor = new MActor ("actor\\jens.act", "aMain");
	CurActor->Load ();
	
	// count rooms
	numRooms = 0;

	FindFile findRoom;
	while (findRoom.Find ("rooms\\*.rm"))
		numRooms++;
	
	// alloc mem & load rooms
	if (numRooms)
		Room = new MRoom[numRooms];

	findRoom.Destroy ();
	
	for (MIndex idxRoom = 0; idxRoom < numRooms; idxRoom++)
	{
		char strPath[256];
		findRoom.Find ("rooms\\*.rm");
		
		sprintf (strPath, "rooms\\%s", findRoom.strFile);
		Room[idxRoom].Load (strPath);
		
		// attach standart actor
		Room[idxRoom].CurActor = CurActor;
	}
	
	CurRoom = GetRoom ("aussen");
	
	// open Command bar
	CmdBar = new MCommandBar;
		
	// open Room mgr
	RoomMgr = new MRoomMgr;

	bActive = true;

	// Enter first room
	CurRoom->Enter ();

	Screen.Clear ();
	App->CurActor->Text->Add ("Let's get it on !");

	Events (CM_CDNOTIFY, 0, 0);
}

void MApplication::Close ()
{	
	CDCommand ("stop cdaudio");
	
	// destroy all rooms
	if (numRooms)
		delete [] Room;

	Room = NULL;
	numRooms = 0;
	
	// free command bar
	delete CmdBar;

	// destroy fonts
	delete [] Font;

	// free room mgr
	delete RoomMgr;

	// destroy actor
	delete CurActor;

	// destroy dialog
	delete CurDialog;

	// destroy registry
	delete Registry;

	LogFloat ("Framerate ~ ", fFrameRate);
}

void MApplication::Render ()
{
	Win->Frequent ();

	static DWORD timeLast = 0;
	static DWORD dwFrames = 0;
	static DWORD timeFrame = 0;

	timeLast += Win->TickDelta;

	// not more than ~40 fps !!
	if (timeLast < 25 || !Win->Enabled || !Win->Active) 
		return;

	// timer
	RoomMgr->Timer ();

	// move actor
	CurActor->Move (timeLast);
	
	// render room & attached actors
	CurRoom->Render (&ScreenBack, timeLast);

	// text output
	CurActor->RenderText (&ScreenBack, timeLast);
	
	// blit the command bar or the dialog
	if (CurDialog->isOpen ())
		CurDialog->Render (&ScreenBack);
	else
		CmdBar->Render (&ScreenBack);

	// flip backbuffer
	CheckDD (Screen.Surface->Flip (NULL, DDFLIP_WAIT ), "flip");

	// Framerate stuff
	dwFrames++;
	timeFrame += timeLast;
	timeLast = 0;
	if (timeFrame >= 2000)
	{
		fFrameRate = 1000.0f * (float)dwFrames / (float)timeFrame;
		dwFrames = 0;
		timeFrame = 0;
	}
}

void MApplication::Events (unsigned MsgID, WORD wParam, long lParam)
{
	POINT posMouse = { LOWORD (lParam), HIWORD (lParam) };
	char strCmd[256];
	int iTrack;
	
	// redirect events to matching object
	switch (MsgID)
	{
		case CM_TALKDONE :
			if (wParam)
			{
				char strID[5];
				sprintf (strID, "#%d", wParam);
				
				LPCSTR strArg [2] = {strID, NULL};
				RoomMgr->DoCmd (CurRoom, CMD_EVENT, strArg);
			}
			else if (CurDialog->isOpen ())
				CurDialog->Run ();
			break;

		case CM_ACTORDONE :
			if (wParam)
			{
				char strID[5];
				sprintf (strID, "#%d", wParam);
				
				LPCSTR strArg [2] = {strID, NULL};
				RoomMgr->DoCmd (CurRoom, CMD_EVENT, strArg);
			}
			else if (CurActor == (MActor *) lParam)
				CmdBar->Execute ();
			break;
		
		case CM_CDNOTIFY:	
			iTrack = rnd (CD_RANDOMTRACKS) + 7;
			sprintf (strCmd, "play cdaudio from %d to %d", iTrack, iTrack + 1);
			CDCommand (strCmd);
			break;

		case WM_LBUTTONDOWN :
			if (bActive && PtInRect (&CmdBar->rectPos, posMouse))
			{
				if (CurDialog->isOpen ())
					CurDialog->Click (posMouse);
				else
					CmdBar->Click (posMouse);
			}
			else if (bActive && PtInRect (&CurRoom->rectPos, posMouse) && !CurDialog->isOpen ())
			{
				CurRoom->Click (posMouse);
			}
			break;
		
		case WM_RBUTTONDOWN :
			if (bActive && !CurDialog->isOpen ())
				CmdBar->Cancel ();
			break;

		case WM_KEYDOWN :
			if (wParam >= VK_F1 && wParam <= VK_F5 && bActive && !CurDialog->isOpen ())
			{
				CmdBar->Cancel ();
				CurDialog->Open ("dialogs\\options.dlg");
			}
			if (wParam == 190)
			{
				CurActor->Text->Skip ();
				CurRoom->Skip ();
			}
			break;
	}
}

MRoom *MApplication::GetRoom (LPCSTR strRoom)
{
	// find the matching room
	for (MIndex idxRoom = 0; idxRoom < numRooms; idxRoom++)
	{
		if (!_stricmp (strRoom, Room[idxRoom].strName))
			return &Room[idxRoom];
	}
	return NULL;
}

MFont *MApplication::GetFont (LPCSTR strFont)
{
	// find the matching font
	for (MIndex idxFont = 0; idxFont < numFonts; idxFont++)
	{
		if (!_stricmp (strFont, Font[idxFont].strName))
			return &Font[idxFont];
	}
	return NULL;
}

void MApplication::Load (int iPos)
{
	char strBuffer [256];
	sprintf (strBuffer, "game%d.sav", iPos);

	// open savegame
	FILE *fileLoad = fopen (strBuffer, "rb");
	if (!fileLoad)
	{
		App->CurActor->Text->Add ("< Fehler beim Laden des Spielstands >");
		return;
	}

	// check version
	int iVersion;
	ReadData (fileLoad, iVersion);
	if (iVersion < 14)
	{
		App->CurActor->Text->Add ("< Der Spielstand stammt von einer%anderen Version des Spiels >");
		fclose (fileLoad);
		return;
	}

	// get the matching room
	ReadString (fileLoad, strBuffer);
	if (_stricmp (strBuffer, CurRoom->strName))
	{
		CurRoom->Leave (false);
		CurRoom = GetRoom (strBuffer);
		CurRoom->Enter (false);
	}

	// init the command bar
	CmdBar->iInit = 2;
	CmdBar->Cancel ();

	CmdBar->ItemStore.LoadGame (fileLoad);
	Registry->Load (fileLoad);

	for (MIndex idxRoom = 0; idxRoom < numRooms; idxRoom++)
	{
		ReadString (fileLoad, strBuffer);
		GetRoom(strBuffer)->LoadGame (fileLoad, iVersion);
	}
	CurActor->LoadGame (fileLoad);

	RoomMgr->LoadGame (fileLoad);

	fclose (fileLoad);

	App->CurActor->Text->Add ("< Spielstand geladen >");
}

void MApplication::Save (int iPos)
{
	char strBuffer [256];
	sprintf (strBuffer, "game%d.sav", iPos);
	
	// open savegame
	FILE *fileSave = fopen (strBuffer, "wb");
	
	// save version, curroom
	int iVersion = VERSION;
	WriteData (fileSave, iVersion);
	WriteString (fileSave, CurRoom->strName);
	
	CmdBar->ItemStore.SaveGame (fileSave);
	Registry->Save (fileSave);

	for (MIndex idxRoom = 0; idxRoom < numRooms; idxRoom++)
	{
		WriteString (fileSave, Room[idxRoom].strName);
		Room[idxRoom].SaveGame (fileSave);
	}
	CurActor->SaveGame (fileSave);

	RoomMgr->SaveGame (fileSave);

	fclose (fileSave);

	App->CurActor->Text->Add ("< Spielstand gespeichert >");
}