// Abiventure app Mgr
// devilducky@gmx.net

#include "tools.h"
#include "filetools.h"
#include "graphtool.h"
#include "winfunc.h"
#include "appmgr.h"

MCommandBar::MCommandBar ()
{
	Create ();
}
MCommandBar::~MCommandBar ()
{
	Destroy ();
}

void MCommandBar::Create ()
{
	char strPath[256];
	// load all button images

	for (MIndex idxButton = 0; idxButton < NUM_BUTTONS; idxButton++)
	{
		sprintf (strPath, "cmdBar\\button%d.bmp", idxButton);
		imgButton[idxButton].Load (strPath);
		
		sprintf (strPath, "cmdBar\\button%da.bmp", idxButton);
		imgButtonActive[idxButton].Load (strPath);
	}
	imgArrow[0].Load ("cmdBar\\arrowup.bmp");
	imgArrow[1].Load ("cmdBar\\arrowdn.bmp");
	imgArrowActive[0].Load ("cmdBar\\arrowupa.bmp");
	imgArrowActive[1].Load ("cmdBar\\arrowdna.bmp");

	rectPos.top = 450;
	rectPos.left = 0;
	rectPos.bottom = 599;
	rectPos.right = 799;

	iArgs = 0;
	iCurCmd = CMD_WALK;
	objCur[0] = NULL;
	objCur[1] = NULL;
	actCur[0] = NULL;
	actCur[1] = NULL;
	itmCur[0] = NULL;
	itmCur[1] = NULL;
	bRunning = false;

	ItemStore.Load ("items\\all.itm");
	
	// attach fonts
	for (MIndex idxFont = 0; idxFont < App->numFonts; idxFont++)
	{
		if (!strcmp (FONT_CMD, App->Font[idxFont].strName))
			fntCmd = &App->Font[idxFont];
		
		if (!strcmp (FONT_ACTIVE, App->Font[idxFont].strName))
			fntActive = &App->Font[idxFont];
	}

	iInit = 2;

	Log ("Command bar opened.");
}

void MCommandBar::Destroy ()
{
	Log ("Command bar destroyed.");
}

void MCommandBar::Render (MImage *imgDest)
{
	// clear the titlebar
	DDBLTFX descFX;
	memset (&descFX, 0, sizeof (descFX));
	descFX.dwSize = sizeof (descFX);
	descFX.dwFillColor = 0;

	RECT rectTitle = { 0, TEXT_POS_Y, 800, BUTTONBAR_Y + 5};
	CheckDD (imgDest->Surface->Blt (&rectTitle, NULL, NULL, DDBLT_COLORFILL, &descFX), "cmd clear");

	// init stuff (itembar, etc.)
	if (iInit)
		ItemStore.bRedraw = true;

	// blit items if invalid
	if (ItemStore.bRedraw)
		ItemStore.Render (imgDest);
	
	// blit all buttons
	for (MIndex idxButton = 0; idxButton < NUM_BUTTONS; idxButton++)
	{
		int posButtonX = BUTTONBAR_X + BUTTON_LEN_X * (idxButton / BUTTON_LINES);
		int posButtonY = BUTTONBAR_Y + BUTTON_LEN_Y * (idxButton % BUTTON_LINES);

		if (Win->posMouse.x >= posButtonX && Win->posMouse.x < posButtonX + BUTTON_LEN_X &&
			Win->posMouse.y >= posButtonY && Win->posMouse.y < posButtonY + BUTTON_LEN_Y )
		{
			imgDest->BlitComplete (posButtonX, posButtonY, imgButtonActive [idxButton]);
		}
		else
		{
			imgDest->BlitComplete (posButtonX, posButtonY, imgButton [idxButton]);
		}
	}
	// blit the arrows
	if (Win->posMouse.x >= ARROW_X && Win->posMouse.x < ARROW_X + imgArrow[0].Width &&
		Win->posMouse.y >= ARROW_Y1 && Win->posMouse.y < ARROW_Y1 + imgArrow[0].Height )
		imgDest->BlitComplete (ARROW_X, ARROW_Y1, imgArrowActive[0]);
	else
		imgDest->BlitComplete (ARROW_X, ARROW_Y1, imgArrow[0]);
	
	if (Win->posMouse.x >= ARROW_X && Win->posMouse.x < ARROW_X + imgArrow[0].Width &&
		Win->posMouse.y >= ARROW_Y2 && Win->posMouse.y < ARROW_Y2 + imgArrow[0].Height )
		imgDest->BlitComplete (ARROW_X, ARROW_Y2, imgArrowActive[1]);
	else
		imgDest->BlitComplete (ARROW_X, ARROW_Y2, imgArrow[1]);
	
	// build text string
	char strText[256];

	switch (iCurCmd)
	{
		case CMD_WALK:
			strcpy (strText, "Gehe zu");
			break;
		case CMD_GIVE:
			strcpy (strText, "Gib");
			break;
		case CMD_OPEN:
			strcpy (strText, "ffne");
			break;
		case CMD_CLOSE:
			strcpy (strText, "Schliee");
			break;
		case CMD_PICKUP:
			strcpy (strText, "Nimm");
			break;
		case CMD_LOOKAT:
			strcpy (strText, "Sieh an");
			break;
		case CMD_TALKTO:
			strcpy (strText, "Sprich mit");
			break;
		case CMD_USE:
			strcpy (strText, "Benutze");
			break;
		case CMD_PUSH:
			strcpy (strText, "Drcke");
			break;
		case CMD_PULL:
			strcpy (strText, "Ziehe");
			break;
	}

	// get temporary selected object
	strcpy (strMoveObj, "");
	App->CurRoom->MouseMove (Win->posMouse);
	ItemStore.MouseMove (Win->posMouse);

	// first arg
	if (iArgs >= 1)
	{
		strcat (strText, " ");

		if (objCur [0])
			strcat (strText, objCur[0]->strDesc);
		else if (itmCur [0])
			strcat (strText, itmCur[0]->strDesc);
		else
			strcat (strText, actCur[0]->strDesc);

		if (iCurCmd == CMD_GIVE)
			strcat (strText, " an ");

		if (iCurCmd == CMD_USE)
		{
			if (objCur [0])
			{
				if (objCur[0]->bUseWith)
					strcat (strText, " mit ");
			}
			else if (itmCur [0])
			{
				if (itmCur[0]->bUseWith)
					strcat (strText, " mit ");
			}
			else if (actCur [0])
			{
				if (actCur[0]->bUseWith)
					strcat (strText, " mit ");
			}
		}

		if (iArgs >= 2)
		{
			if (objCur [1])
				strcat (strText, objCur[1]->strDesc);
			else if (itmCur [1])
				strcat (strText, itmCur[1]->strDesc);
			else
				strcat (strText, actCur[1]->strDesc);
		}	
		else
		{
			if (!bRunning)
				strcat (strText, strMoveObj);
		}
	}
	else
	{
		if (!bRunning)
		{
			strcat (strText, " ");
			strcat (strText, strMoveObj);
		}
	}
	
	fntCmd->PrintCenterText (400, TEXT_POS_Y, strText, imgDest);

	if (iInit)
		iInit--;
}

void MCommandBar::Click (POINT posMouse)
{
	if (PtInRect (&ItemStore.rectPos, posMouse))
	{
		ItemStore.Click (posMouse);
		return;
	}

	for (MIndex idxButton = 0; idxButton < NUM_BUTTONS; idxButton++)
	{
		if (posMouse.x >= BUTTONBAR_X + BUTTON_LEN_X * (idxButton / BUTTON_LINES) && posMouse.x < BUTTONBAR_X + BUTTON_LEN_X * (idxButton / BUTTON_LINES + 1) &&
			posMouse.y >= BUTTONBAR_Y + BUTTON_LEN_Y * (idxButton % BUTTON_LINES) && posMouse.y < BUTTONBAR_Y + BUTTON_LEN_Y * (idxButton % BUTTON_LINES + 1))
		{
			SetCmd (idxButton);
			return;
		}
	}
	if (posMouse.x >= ARROW_X && posMouse.x < ARROW_X + imgArrow[0].Width && posMouse.y >= ARROW_Y1 && posMouse.y < ARROW_Y1 + imgArrow[0].Height )
	{
		ItemStore.Scroll (-1);
		return;
	}

	if (posMouse.x >= ARROW_X && posMouse.x < ARROW_X + imgArrow[1].Width && posMouse.y >= ARROW_Y2 && posMouse.y < ARROW_Y2 + imgArrow[1].Height )
	{
		ItemStore.Scroll (1);
		return;
	}
}

void MCommandBar::Cancel ()
{
	iCurCmd = CMD_WALK;
	iArgs = 0;
	bRunning = false;
	strMoveObj[0] = '\0';
}

void MCommandBar::SetCmd (int iCommand)
{
	if (iCurCmd != iCommand)
	{
		iCurCmd = iCommand;
		iArgs = 0;
		bRunning = false;
	}
}

void MCommandBar::SetObject (MObject *objClick)
{
	// determine expected args
	int iExpectedArgs;
	
	switch (iCurCmd)
	{
		case CMD_GIVE:
			iExpectedArgs = 2;
			break;
		case CMD_USE:
			if (!iArgs)
				iExpectedArgs = objClick->bUseWith ? 2 : 1;
			else
			{
				if (objCur[0])
					iExpectedArgs = objCur[0]->bUseWith ? 2 : 1;
				else if (itmCur[0])
					iExpectedArgs = itmCur[0]->bUseWith ? 2 : 1;
				else
					iExpectedArgs = actCur[0]->bUseWith ? 2 : 1;
			}
			break;
		default :
			iExpectedArgs = 1;
	}

	// cancel ?
	if (bRunning)
	{
		if (objClick != objCur [iArgs - 1])
		{
			bRunning = false;
			iArgs = 1;
			objCur [0] = objClick;
		
			if (iArgs == iExpectedArgs)
				RunCommand ();
		}
	}
	else
	{
		objCur[iArgs] = objClick;
		iArgs++;
	
		if (iArgs == iExpectedArgs)
			RunCommand ();
	}
}

void MCommandBar::SetActor (MActor *actClick)
{
	// determine expected args
	int iExpectedArgs;
	
	switch (iCurCmd)
	{
		case CMD_GIVE:
			iExpectedArgs = 2;
			break;
		case CMD_USE:
			if (!iArgs)
				iExpectedArgs = actClick->bUseWith ? 2 : 1;
			else
			{
				if (objCur[0])
					iExpectedArgs = objCur[0]->bUseWith ? 2 : 1;
				else if (itmCur[0])
					iExpectedArgs = itmCur[0]->bUseWith ? 2 : 1;
				else
					iExpectedArgs = actCur[0]->bUseWith ? 2 : 1;
			}
			break;
		default :
			iExpectedArgs = 1;
	}

	// cancel ?
	if (bRunning)
	{
		if (objCur [iArgs - 1] || itmCur[iArgs - 1] || actClick != actCur [iArgs - 1])
		{
			bRunning = false;
			iArgs = 1;
			objCur [0] = NULL;
			itmCur [0] = NULL;
			actCur [0] = actClick;
		
			if (iArgs == iExpectedArgs)
				RunCommand ();
		}
	}
	else
	{
		objCur[iArgs] = NULL;
		itmCur[iArgs] = NULL;
		actCur[iArgs] = actClick;
		iArgs++;
	
		if (iArgs == iExpectedArgs)
			RunCommand ();
	}
}

void MCommandBar::SetItem (MItem *itmClick)
{
	// determine expected args
	int iExpectedArgs;
	
	switch (iCurCmd)
	{
		case CMD_GIVE:
			iExpectedArgs = 2;
			break;
		case CMD_USE:
			if (!iArgs)
				iExpectedArgs = itmClick->bUseWith ? 2 : 1;
			else
			{
				if (objCur[0])
					iExpectedArgs = objCur[0]->bUseWith ? 2 : 1;
				else if (itmCur[0])
					iExpectedArgs = itmCur[0]->bUseWith ? 2 : 1;
				else
					iExpectedArgs = actCur[0]->bUseWith ? 2 : 1;
			}
			break;
		default :
			iExpectedArgs = 1;
	}

	// cancel ?
	if (bRunning)
	{
		if (objCur[iArgs - 1] || itmClick != itmCur [iArgs - 1])
		{
			bRunning = false;
			iArgs = 1;
			objCur [0] = NULL;
			itmCur [0] = itmClick;
		
			if (iArgs == iExpectedArgs)
				RunCommand ();
		}
	}
	else
	{
		objCur[iArgs] = NULL;
		itmCur[iArgs] = itmClick;
		iArgs++;
	
		if (iArgs == iExpectedArgs)
			RunCommand ();
	}
}

void MCommandBar::SetMove (LPCSTR strObjMove)
{
	strcpy (strMoveObj, strObjMove);
}

void MCommandBar::RunCommand ()
{
	bRunning = true;

	// no walk on flatmaps
	if (App->CurRoom->ZMap == NULL)
	{
		Execute ();
		return;
	}

	if (objCur[0])
	{
		App->CurActor->WalkTo (objCur[0]->posWalk, objCur[0]->dirWalk);
	}
	else if (iArgs > 1 && objCur[1])
	{
		App->CurActor->WalkTo (objCur[1]->posWalk, objCur[1]->dirWalk);
	}
	else if (!itmCur[0] && actCur[0])
	{
		POINT posWalk = actCur[0]->getWalkPoint (App->CurActor->posCur);
		
		App->CurActor->WalkTo (posWalk, actCur[0]->getWalkDir (posWalk));
	}
	else if (iArgs > 1 && !itmCur[1] && actCur[1])
	{
		POINT posWalk = actCur[1]->getWalkPoint (App->CurActor->posCur);
		
		App->CurActor->WalkTo (posWalk, actCur[1]->getWalkDir (posWalk));
	}
	else
	{
		Execute ();
	}
}

void MCommandBar::Execute ()
{
	if (!bRunning)
		return;
	
	LPCSTR strArg[2];
	strArg[0] = objCur[0] ? objCur[0]->strName : (itmCur[0] ? itmCur[0]->strName : actCur[0]->strName);
	
	if (iArgs >= 2)
		strArg[1] = objCur [1] ? objCur[1]->strName : (itmCur[1] ? itmCur[1]->strName : actCur[1]->strName);
	else
		strArg[1] = NULL;
		
	// if no special action defined, perform standard actions
	if (!App->RoomMgr->DoCmd (App->CurRoom, iCurCmd, strArg))
	{
		switch (iCurCmd)
		{
		case CMD_WALK:
			if (objCur[0] && objCur[0]->iType == OBJECTTYPE_DOOR && objCur[0]->bEnabled)
			{
				App->CurRoom->Leave ();
				App->CurRoom = App->GetRoom (objCur[0]->strObj);
				App->CurRoom->Enter ();
				break;
			}
			break;

		case CMD_TALKTO:
			if (objCur[0] || itmCur[0])
			{
				if (objCur[0] && (objCur[0]->iType == OBJECTTYPE_PERSON || objCur[0]->iType == OBJECTTYPE_GROUP))
					App->CurDialog->Open (objCur[0]->strDialog);
				else
					App->CurActor->Text->Add ("Wie fang ich nur ein%Gesprch mit nem Gegenstand an ??");
			}
			else
			{
				actCur[0]->setTalkDir (App->CurActor->dirCur);
				if (actCur[0]->strDialog)
					App->CurDialog->Open (actCur[0]->strDialog);
				else
					App->CurActor->Text->Add ("Mit dem will ich nicht reden...");
			}
			break;

		case CMD_LOOKAT:
			if (objCur[0] && objCur[0]->strLook)
				App->CurActor->Text->Add (objCur[0]->strLook);
			else if (!objCur[0] && itmCur[0] && itmCur[0]->strLook)
				App->CurActor->Text->Add (itmCur[0]->strLook);
			else if (!objCur[0] && !itmCur[0] && actCur[0] && actCur[0]->strLook)
				App->CurActor->Text->Add (actCur[0]->strLook);
			else
			{
				switch (rnd (5))
				{
				case 0:
					App->CurActor->Text->Add ("ussert ss.");
					break;
				case 1:
					App->CurActor->Text->Add ("Im Jugenstil erbaut.");
					break;
				case 2:
					App->CurActor->Text->Add ("Knuddelig.");
					break;
				case 3:
					App->CurActor->Text->Add ("Knuddelig.");
					break;
				case 4:
					App->CurActor->Text->Add ("Da gibts nix zu gucken.");
					break;
				}
			}
			break;

		case CMD_PICKUP:
			if (!objCur[0] && itmCur[0])
			{
				App->CurActor->Text->Add ("Das habe ich doch schon.");
			}
			else if (objCur[0] && objCur[0]->iType == OBJECTTYPE_ITEM && objCur[0]->bEnabled)
			{
				ItemStore.GetItem (objCur[0]->strObj)->bVisible = true;
				ItemStore.bRedraw = true;
				objCur[0]->bVisible = false;
				objCur[0]->bEnabled = false;
				App->CurRoom->getFrame (objCur[0]->strFrame)->bVisible = ! App->CurRoom->getFrame (objCur[0]->strFrame)->bVisible;
			}
			else
			{
				switch (rnd (4))
				{
				case 0:
					App->CurActor->Text->Add ("Das will ich nicht.");
					break;
				case 1:
					App->CurActor->Text->Add ("Das kann ich nicht nehmen.");
					break;
				case 2:
					App->CurActor->Text->Add ("Da nehm ich lieber nen Kinley");
					break;
				case 3:
					App->CurActor->Text->Add ("N, mag nicht.");
					break;
				}
			}
			break;
		case CMD_PUSH:
		case CMD_PULL:
		case CMD_OPEN:
		case CMD_CLOSE:
			switch (rnd (5))
			{
			case 0:
				App->CurActor->Text->Add ("N, ist zu schwer");
				break;
			case 1:
				App->CurActor->Text->Add ("Mais c'est pas possible de tout");
				break;
			case 2:
				App->CurActor->Text->Add ("Das kann ich nicht bewegen");
				break;
			case 3:
				App->CurActor->Text->Add ("Mag nicht");
				break;
			case 4:
				App->CurActor->Text->Add ("Ich knuddel lieber kleine Mdchen#mit Zpfen.");
				break;
			}
			break;
		case CMD_GIVE:
			switch (rnd (4))
			{
			case 0:
				App->CurActor->Text->Add ("Das behalt ich lieber");
				break;
			case 1:
				App->CurActor->Text->Add ("Das will ich nicht weggeben");
				break;
			case 2:
				App->CurActor->Text->Add ("Das bringt soch eh nix.");
				break;
			case 3:
				App->CurActor->Text->Add ("'Gib Backenwatsche an Spieler'");
				break;
			}
			break;
		case CMD_USE:
			switch (rnd (5))
			{
			case 0:
				App->CurActor->Text->Add ("Erst denken, dann klicken");
				break;
			case 1:
				App->CurActor->Text->Add ("Das muss doch echt nicht sein");
				break;
			case 2:
				App->CurActor->Text->Add ("'Benutze Hammer mit Spieler'");
				break;
			case 3:
				App->CurActor->Text->Add ("Frei nach dem Motto:#'Benutze Stumpfsinn mit Quarktasche'");
				break;
			case 4:
				App->CurActor->Text->Add ("Ach ne du, lass mal.");
				break;
			}
			break;
		}
	}
	Cancel ();
}
