// Abiventure app Mgr
// devilducky@gmx.net

#include "tools.h"
#include "filetools.h"
#include "graphtool.h"
#include "appmgr.h"
#include "winfunc.h"

MDialog::MDialog ()
{
	Create ();
}
MDialog::~MDialog ()
{
	Destroy ();
}

void MDialog::Create ()
{
	fileDialog = NULL;
	strName = NULL;
}
void MDialog::Destroy ()
{
	Close ();
}

void MDialog::Open (LPCSTR strFile)
{
	Close ();

	// open the file
	fileDialog = new TextFile (strFile);

	// get name
	char strBuffer[256];
	fileDialog->FindSetting ("name", strBuffer);
	strName = new char [strlen (strBuffer) + 1];
	strcpy (strName, strBuffer);
	
	// get actors
	for (MIndex idxActor = 0; idxActor < MENU_ACTORS; idxActor++)
	{
		char strKey[100];
		sprintf (strKey, "actor%d", idxActor);

		if (fileDialog->FindSetting (strKey, strBuffer))
		{
			// find that actor
			if (!_stricmp (strBuffer, App->CurActor->strName))
				speTalk[idxActor] = App->CurActor->Text;
			else if (App->CurRoom->getActor (strBuffer))
				speTalk[idxActor] = App->CurRoom->getActor (strBuffer)->Text;
			else if (App->CurRoom->getObject (strBuffer))
				speTalk[idxActor] = App->CurRoom->getObject (strBuffer)->Text;
			
			// shut up
			if (speTalk[idxActor])
				speTalk[idxActor]->Cancel ();
		}
	}
	
	iCleanup = 2;
	
	// start parsing
	numEntries = 0;
	fileDialog->Reset ();
	Run ();
}

void MDialog::Close ()
{
	if (fileDialog)
	{
		// delete name
		delete [] strName;

		// close file
		delete fileDialog;
		fileDialog = NULL;
	}
	if(App->CmdBar)
		App->CmdBar->iInit = 2;
}
void MDialog::Render (MImage *imgDest)
{
	// clear area
	if (iCleanup)
	{
		iCleanup--;

		DDBLTFX descFX;
		memset (&descFX, 0, sizeof (descFX));
		descFX.dwSize = sizeof (descFX);
		descFX.dwFillColor = 0;

		RECT rectDialog = { 0, TEXT_POS_Y, 800, 600 };
		CheckDD (imgDest->Surface->Blt (&rectDialog, NULL, NULL, DDBLT_COLORFILL, &descFX), "dlg clear");
	}

	// draw menu
	for (MIndex idxEntry = 0; idxEntry < numEntries; idxEntry++)
	{
		MFont *fntCur = App->CmdBar->fntCmd;
		
		// activate text ?
		if (Win->posMouse.x >= 15 && Win->posMouse.x <= 400 &&
			Win->posMouse.y >= DIALOG_Y + idxEntry * fntCur->iRowHeight &&
			Win->posMouse.y < DIALOG_Y + (1 + idxEntry) * fntCur->iRowHeight)
			fntCur = App->CmdBar->fntActive;

		fntCur->PrintText (15, DIALOG_Y + idxEntry * fntCur->iRowHeight, strMenu[idxEntry], imgDest);
	}
}

bool MDialog::CheckFunction (char *strID)
{
	long lBackup = fileDialog->GetPos ();
	char strBuf2 [256], strArg[256];
	bool bEnabled = true;
	
	// search for args
	fileDialog->FindSetting(strID, strBuf2, FIND_CUT);
	
	// get function arguments
	Trim (strBuf2);
	strArg[0] = '\0';
	if (strchr (strBuf2, ' '))
		strcpy (strArg, strchr (strBuf2, ' '));

	if (strstr (strArg, " once"))
	{
		char strOID[256];
		sprintf (strOID, "~%s@%s", strID, strName);
		if (App->Registry->Exists (strOID))
			bEnabled = false;
	}
	if (strstr (strArg, " reg_"))
	{
		char strOID[256];
		strcpy (strOID, strstr (strArg, " reg_") + 5);
		if (strchr (strOID, ' '))
			strchr (strOID, ' ') [0] = '\0';

		if (!App->Registry->Exists (strOID))
			bEnabled = false;
	}
	if (strstr (strArg, " is_"))
	{
		char strOID[256], strNum[256];
		strcpy (strOID, strstr (strArg, " is_") + 4);
		strcpy (strNum, strchr (strOID, ' ') + 1);
		if (strchr (strOID, ' '))
			strchr (strOID, ' ') [0] = '\0';
		if (strchr (strNum, ' '))
			strchr (strNum, ' ') [0] = '\0';
		
		if (!App->Registry->Exists (strOID) || App->Registry->getData (strOID) != atoi (strNum))
			bEnabled = false;
	}
	if (strstr (strArg, " noreg_"))
	{
		char strOID[256];
		strcpy (strOID, strstr (strArg, " noreg_") + 7);
		if (strchr (strOID, ' '))
			strchr (strOID, ' ') [0] = '\0';

		if (App->Registry->Exists (strOID))
			bEnabled = false;
	}
	if (strstr (strArg, " has_"))
	{
		char strOID[256];
		strcpy (strOID, strstr (strArg, " has_") + 5);
		if (strchr (strOID, ' '))
			strchr (strOID, ' ') [0] = '\0';

		if (!App->CmdBar->ItemStore.GetItem (strOID)->bVisible)
			bEnabled = false;
	}

	fileDialog->SetPos (lBackup);
	return bEnabled;
}

void MDialog::ProcessArgs (char *strFunc, char *strID, char *strEntry)
{
	char strBuffer[256];
	char strArg[256];

	strcpy (strBuffer, strFunc);

	// get function arguments
	Trim (strBuffer);
	strArg[0] = '\0';
	if (strchr (strBuffer, ' '))
		strcpy (strArg, strchr (strBuffer, ' '));

	if (strstr (strArg, " once"))
	{
		char strRID[256];
		// add in registry
		sprintf (strRID, "~%s@%s", strID, strName);
		App->Registry->Add (strRID, true);
	}
	// print the entry ?
	if (strstr (strArg, " noprint") || !strEntry)
		Run ();
	else
		App->CurActor->Text->Add (strEntry, true);
}

void MDialog::Run ()
{
	char strBuffer[256], strText[256];

	// process file
	while (fileDialog->GetLine (strBuffer))
	{
		Trim (strBuffer);
		// text output
		if (strBuffer[0] >= '0' && strBuffer[0] <= '9')
		{
			MSpeechUnit *speSpeak = speTalk [strBuffer[0] - '0'];
			if (speSpeak)
			{
				strcpy (strText, &strBuffer[1]);
				Trim (strText);
				speSpeak->Add (strText, true);
				break;
			}
		}
		// synchronous text output
		else if (strBuffer[0] == '*' && strBuffer[1] >= '0' && strBuffer[1] <= '9')
		{
			MSpeechUnit *speSpeak = speTalk [strBuffer[1] - '0'];
			if (speSpeak)
			{
				strcpy (strText, &strBuffer[2]);
				Trim (strText);
				speSpeak->Add (strText);
			}
		}
		// ignore def's
		else if (strchr (strBuffer, '='));
		// menu entries
		else if (strchr (strBuffer, ':'))
		{
			char strID[30];

			// extract ID
			strncpy (strID + 1, strBuffer, 30);
			strID [0] = '>';
			strID [29] = '\0';
			strchr (strID, ':') [0] = '\0';
			
			if (CheckFunction (strID))
			{				
				// okay, add entry
				strcpy (strMenuID [numEntries], strID);
				strcpy (strMenu [numEntries], strchr (strBuffer, ':') + 1);
				numEntries++;
			}
		}
		// sub routine
		else if (strBuffer[0] == '>') 
		{
			// wait for menu ?
			if (numEntries)
				break;
		}
		// jump
		else if (tolower(strBuffer[0]) >= 'a' && tolower(strBuffer[0]) <= 'z')
		{
			char strID[256];
			strcpy (strID, ">");
			strcat (strID, strBuffer);

			if (CheckFunction (strID))
			{
				char strBuf2 [256];
				fileDialog->FindSetting (strID, strBuf2, FIND_CUT);
				ProcessArgs (strBuf2, strID, NULL);
				break;
			}
		}
		// system command
		else if (!_stricmp (strBuffer, "#quit"))
		{
			Close ();
			break;
		}
		else if (!_strnicmp (strBuffer, "#call ", 6))
		{
			char strFunc [256];
			int iArg = 0;
			strcpy (strFunc, strBuffer + 6);
			if (strchr (strFunc, ' '))
			{
				iArg = atoi (strchr (strFunc, ' ') + 1);
				strchr (strFunc, ' ') [0] = '\0';
			}
			App->RoomMgr->DialogCmd (strFunc, iArg);
		}
		else if (!_stricmp (strBuffer, "#stop"))
		{
			break;
		}
		else if (!_strnicmp (strBuffer, "#reg_", 5))
		{
			if (!App->Registry->Exists (strBuffer + 5))
				App->Registry->Add (strBuffer + 5);
		}
		else if (!_strnicmp (strBuffer, "#regdel_", 8))
		{
			if (App->Registry->Exists (strBuffer + 8))
				App->Registry->Remove (strBuffer + 8);
		}
		else if (!_strnicmp (strBuffer, "#set_", 5))
		{
			char strID[100];
			strcpy (strID, strBuffer + 5);
			strchr (strID, ' ') [0] = '\0';
			if (!App->Registry->Exists (strID))
				App->Registry->Add (strID);
			App->Registry->setData (strID, atol (strchr (strBuffer + 5, ' ') + 1));
		}
	}	
}

void MDialog::Click (POINT posMouse)
{	
	for (MIndex idxEntry = 0; idxEntry < numEntries; idxEntry++)
	{
		// selected ?
		if (posMouse.x >= 15 && posMouse.x <= 400 &&
			posMouse.y >= DIALOG_Y + idxEntry * App->CmdBar->fntCmd->iRowHeight &&
			posMouse.y < DIALOG_Y + (1 + idxEntry) * App->CmdBar->fntCmd->iRowHeight)
		{
			// access subroutine
			char strBuffer[256];

			if (fileDialog->FindSetting(strMenuID [idxEntry], strBuffer, FIND_CUT))
			{
				numEntries = 0;
				iCleanup = 2;
				ProcessArgs (strBuffer, strMenuID [idxEntry], strMenu [idxEntry]);
				break;
			}
		}
	}
}