// Abiventure app Mgr
// devilducky@gmx.net

#include "tools.h"
#include "filetools.h"
#include "graphtool.h"
#include "appmgr.h"

MRegistry::MRegistry ()
{
	Create ();
}
MRegistry::~MRegistry ()
{
	Destroy ();
}

void MRegistry::Create ()
{
	numRegs = 0;
	Data = NULL;
}

void MRegistry::Destroy ()
{
	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		if (Data[idxReg].strName)
			delete Data[idxReg].strName;
	}

	if (numRegs)
		free (Data);

	Create ();
}

bool MRegistry::Exists (char *strName)
{
	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		if (!_stricmp (strName, Data[idxReg].strName))
			return true;
	}
	return false;
}

long MRegistry::getData (char *strName)
{
	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		if (!_stricmp (strName, Data[idxReg].strName))
			return Data[idxReg].lData;
	}
	return 0;
}

void MRegistry::setData (char *strName, long lData)
{
	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		if (!_stricmp (strName, Data[idxReg].strName))
			Data[idxReg].lData = lData;
	}
}

void MRegistry::Add (char *strName, long lData)
{
	// resize array
	numRegs++;
	Data = (RegData *) realloc (Data, sizeof (RegData) * numRegs);
	
	// fill in data
	Data[numRegs - 1].strName = new char [strlen (strName) + 1];
	strcpy (Data[numRegs - 1].strName, strName);
	Data[numRegs - 1].lData = lData;
}

void MRegistry::Remove (char *strName)
{
	// locate element
	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		if (!_stricmp (strName, Data[idxReg].strName))
		{
			// destroy !!
			delete Data[idxReg].strName;
			
			if (idxReg < numRegs - 1)
				memmove (&Data[idxReg], &Data[idxReg + 1], sizeof (RegData) * (numRegs - idxReg - 1));
			
			// resize array
			numRegs--;
			Data = (RegData *) realloc (Data, sizeof (RegData) * numRegs);
			return;
		}
	}	
}

void MRegistry::Save (FILE *fileSave)
{
	WriteData (fileSave, numRegs);

	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		WriteString (fileSave, Data[idxReg].strName);
		WriteData (fileSave, Data[idxReg].lData);
	}
}

void MRegistry::Load (FILE *fileLoad)
{
	Destroy ();
	
	ReadData (fileLoad, numRegs);
	Data = (RegData *) realloc (Data, sizeof (RegData) * numRegs);
	
	for (MIndex idxReg = 0; idxReg < numRegs; idxReg++)
	{
		Data[idxReg].strName = NULL;
		ReadDynamicString (fileLoad, Data[idxReg].strName);
		ReadData (fileLoad, Data[idxReg].lData);
	}
}
