// Abiventure Room Mgr
// devilducky@gmx.net

#include "tools.h"
#include "filetools.h"
#include "graphtool.h"
#include "appmgr.h"
#include "winfunc.h"
#include "mmsystem.h"
#include "rooms.h"

MRoomMgr::MRoomMgr ()
{
	Create ();
}
MRoomMgr::~MRoomMgr ()
{
	Destroy ();
}

void MRoomMgr::Create ()
{
	App->Registry->Add ("Pause");
	App->Registry->Add ("Oben", 0);
	App->Registry->Add ("HM", 0);
	App->Registry->Add ("Feist", 0);
	strOldRoom [0] = '\0';
	memset (iCombo, 0, sizeof (int) * 3);
	timeGong = timeGetTime () + 300000;
	timeGlatt = timeGetTime () + 500000;
	timeCD = timeGetTime () + 60000;
}

void MRoomMgr::Destroy ()
{

}

void MRoomMgr::ChangeGong ()
{
	timeGong = Win->Ticks + 240000;

	if (App->Registry->Exists ("Pause"))
		App->Registry->Remove ("Pause");
	else
		App->Registry->Add ("Pause");

	if (App->Registry->Exists ("GlattWeg") && !App->Registry->Exists ("GlattPheromone"))
		App->Registry->Remove ("GlattWeg");
	
	if (App->Registry->Exists ("Pause") || App->Registry->Exists ("GlattWeg"))
		timeGlatt = Win->Ticks + 500000;
	else
		timeGlatt = Win->Ticks + 140000;

	if (!App->Registry->Exists ("Pause"))
		App->Registry->setData ("Oben", (App->Registry->getData ("Oben") + 1) % 3);

	MSpeechUnit *Gong = new MSpeechUnit (App->GetFont("white"), 0);
	App->CurRoom->AttachUnit (Gong);
	Gong->Set (100, 40);
			
	// wait 1s
	DWORD timeWait = timeGetTime () + 500;
	while (timeWait > timeGetTime()) 
		App->Render ();

	Gong->Add ("*Ding*Dang*Dong*");
	PlaySound ("sound\\schbell.wav", NULL, SND_FILENAME |SND_ASYNC );
	// wait 1s
	timeWait = timeGetTime () + 1000;
	while (timeWait > timeGetTime()) 
		App->Render ();

	if (App->Registry->Exists ("Pause"))
		App->CurActor->Text->Add ("Jetzt ist Pause");
	else
		App->CurActor->Text->Add ("Jetzt fngt die Stunde an");
	
	// wait 0,6s
	timeWait = timeGetTime () + 1000;
	while (timeWait > timeGetTime()) 
		App->Render ();

	Gong->Cancel ();
	App->CurRoom->DetachUnit (Gong);
	delete Gong;
}

void MRoomMgr::Timer ()
{
	if (Win->Ticks >= timeCD)
	{
		timeCD = Win->Ticks + 10000;
		// check if cd audio is running
		char strCheck [256];

		mciSendString ("status cdaudio mode", strCheck, 255, NULL);
		
		// if not playing, start a random track
		if (_stricmp (strCheck, "playing"))
			App->Events (CM_CDNOTIFY, 0, 0);
	}
	
	if (App->CurDialog->isOpen () || !App->bActive )
		return;

	if (App->Registry->Exists ("FormelTimer") && Win->Ticks >= timeDaimon)
	{
		if (App->CmdBar->ItemStore.GetItem ("iFormelC")->bVisible)
			App->CurRoom->getFrame ("fDaimonG1")->bVisible = true;
		if (App->CmdBar->ItemStore.GetItem ("iFormelTE")->bVisible)
			App->CurRoom->getFrame ("fDaimonG2")->bVisible = true;
		if (App->CmdBar->ItemStore.GetItem ("iFormelM")->bVisible)
			App->CurRoom->getFrame ("fDaimonG3")->bVisible = true;
		if (App->CmdBar->ItemStore.GetItem ("iFormelTM")->bVisible)
			App->CurRoom->getFrame ("fDaimonG4")->bVisible = true;
		if (App->CmdBar->ItemStore.GetItem ("iFormelP")->bVisible)
			App->CurRoom->getFrame ("fDaimonG5")->bVisible = true;
		App->CurRoom->getObject ("oDaimon")->Text->Add ("HAHAHAHAHA");
		App->Registry->Remove ("FormelTimer");
	}
	if (!_stricmp (App->CurRoom->strName, "chemie") && Win->Ticks >= timeTuer && !App->CurRoom->getObject ("oSchiebetuer")->bVisible)
	{
		if (App->CurRoom->getFrame ("fSchiebetuer1")->bVisible)
		{
			iOldTuer = 1;
			timePush = Win->Ticks + 4000;
			App->CurRoom->getFrame ("fSchiebetuer1")->bVisible = false;
		}
		else if (App->CurRoom->getFrame ("fSchiebetuer2")->bVisible)
		{
			iOldTuer = 2;
			timePush = Win->Ticks + 4000;
			App->CurRoom->getFrame ("fSchiebetuer2")->bVisible = false;
		}
		else
		{
			iOldTuer = 0;
			if (rnd (2))
				App->CurRoom->getFrame ("fSchiebetuer1")->bVisible = true;
			else
				App->CurRoom->getFrame ("fSchiebetuer2")->bVisible = true;
		}
		timeTuer = Win->Ticks + 4000 * (rnd (5) + 1);
	}
	
	if (App->Registry->Exists ("StefanosWeg") && Win->Ticks >= timeZettel)
	{
		App->Registry->Remove ("StefanosWeg");
		App->GetRoom ("Sekretar")->getFrame ("fEZettel")->bVisible = true;
	}
	if (Win->Ticks >= timeGong && !App->Registry->Exists ("GongTot"))
	{
		if (!_stricmp (App->CurRoom->strName, "aula") || !_stricmp (App->CurRoom->strName, "aulalite") ||
			!_stricmp (App->CurRoom->strName, "kaffeeautomat") || !_stricmp (App->CurRoom->strName, "schulhof") ||
			!_stricmp (App->CurRoom->strName, "schulhoflite") || !_stricmp (App->CurRoom->strName, "nacht1") ||
			!_stricmp (App->CurRoom->strName, "nacht2") || !_stricmp (App->CurRoom->strName, "daimon1") ||
			!_stricmp (App->CurRoom->strName, "tafel1") || !_stricmp (App->CurRoom->strName, "tafel2") ||
			!_stricmp (App->CurRoom->strName, "daimon2") || !_stricmp (App->CurRoom->strName, "klo") ||
			!_stricmp (App->CurRoom->strName, "sekretar") || !_stricmp (App->CurRoom->strName, "englisch"))
			timeGong = Win->Ticks + 10000;
		else
			ChangeGong ();
	}
	if (Win->Ticks >= timeFallert && App->Registry->Exists ("FallertEvent"))
	{
		if (!_stricmp (App->CurRoom->strName, "physik") || !_stricmp (App->CurRoom->strName, "nacht1") ||
			!_stricmp (App->CurRoom->strName, "nacht2") || !_stricmp (App->CurRoom->strName, "daimon1") ||
			!_stricmp (App->CurRoom->strName, "daimon2"))
			timeFallert = Win->Ticks + 10000;
		else
		{
			strcpy (strOldRoom, App->CurRoom->strName);
			App->Registry->Add ("FallertKassette");
			App->Registry->Remove ("FallertEvent");
			App->CurRoom->Leave ();
			App->CurRoom = App->GetRoom ("physik");
			App->CurRoom->Enter ();
		}
	}
	if (Win->Ticks >= timeGlatt)
	{
		if (App->Registry->Exists ("GlattWeg"))
		{
			if (!App->Registry->Exists ("GlattPheromone"))
			{
				if (!_stricmp (App->CurRoom->strName, "teraum"))
					timeGlatt = Win->Ticks + 10000;
				else
				{
					App->Registry->Remove ("GlattWeg");
					timeGlatt = Win->Ticks + 500000;
				}
			}
		}
		else
		{
			if (!_stricmp (App->CurRoom->strName, "teraum") || !_stricmp (App->CurRoom->strName, "tegang") ||
				!_stricmp (App->CurRoom->strName, "nacht1") || !_stricmp (App->CurRoom->strName, "nacht2") ||
				!_stricmp (App->CurRoom->strName, "daimon1") || !_stricmp (App->CurRoom->strName, "daimon2"))
				timeGlatt = Win->Ticks + 10000;
			else
			{
				App->Registry->Add ("GlattWeg");
				timeGlatt = Win->Ticks + 40000;

				MSpeechUnit *Gong = new MSpeechUnit (App->GetFont("white"), 0);
				App->CurRoom->AttachUnit (Gong);
				Gong->Set (100, 40);
				Gong->Add ("*Achtung fr eine Durchsage :#Herr Glatt bitte ins Sekretariat*");
				PlaySound ("sound\\ding.wav", NULL, SND_FILENAME |SND_ASYNC );
			
				// wait 1s
				DWORD timeWait = timeGetTime () + 7000;
				while (timeWait > timeGetTime()) 
					App->Render ();

				App->CurActor->Text->Add ("(Was der da wohl immer macht ?)");
				
				Gong->Cancel ();
				App->CurRoom->DetachUnit (Gong);
				delete Gong;
			}
		}
	}
}

bool MRoomMgr::DoCmd (MRoom *Room, int iCmd, LPCSTR strArg[2])
{
	MRooms Rooms (iCmd, strArg);
	
	if (Rooms.All (Room->strName))
		return true;

	if (!_stricmp (Room->strName, "aussen"))
		return Rooms.Aussen ();
	if (!_stricmp (Room->strName, "tafel1"))
		return Rooms.Tafel1 ();
	if (!_stricmp (Room->strName, "tafel2"))
		return Rooms.Tafel2 ();
	if (!_stricmp (Room->strName, "englisch"))
		return Rooms.Englisch ();
	if (!_stricmp (Room->strName, "physik"))
		return Rooms.Physik ();
	if (!_stricmp (Room->strName, "flagge"))
		return Rooms.Flagge ();
	if (!_stricmp (Room->strName, "chemie"))
		return Rooms.Chemie ();
	if (!_stricmp (Room->strName, "sporthalle"))
		return Rooms.Sport ();
	if (!_stricmp (Room->strName, "fluroben"))
		return Rooms.FlurOben ();
	if (!_stricmp (Room->strName, "nacht2"))
		return Rooms.Nacht2 ();
	if (!_stricmp (Room->strName, "daimon2"))
		return Rooms.Daimon2 ();
	if (!_stricmp (Room->strName, "daimon1"))
		return Rooms.Daimon1 ();
	if (!_stricmp (Room->strName, "teraum"))
		return Rooms.TE ();
	if (!_stricmp (Room->strName, "tegang"))
		return Rooms.TEGang ();
	if (!_stricmp (Room->strName, "tmgang"))
		return Rooms.TM ();
	if (!_stricmp (Room->strName, "cgang"))
		return Rooms.CGang ();
	if (!_stricmp (Room->strName, "spind"))
		return Rooms.Spind ();
	if (!_stricmp (Room->strName, "zettel"))
		return Rooms.Zettel ();
	if (!_stricmp (Room->strName, "chemie2"))
		return Rooms.Chemie2 ();
	if (!_stricmp (Room->strName, "kaffeeautomat"))
		return Rooms.Kaffee ();
	if (!_stricmp (Room->strName, "ctgang"))
		return Rooms.CT ();
	if (!_stricmp (Room->strName, "aula"))
		return Rooms.Aula ();
	if (!_stricmp (Room->strName, "aulalite"))
		return Rooms.AulaLite ();
	if (!_stricmp (Room->strName, "schulhof"))
		return Rooms.Schulhof ();
	if (!_stricmp (Room->strName, "schulhoflite"))
		return Rooms.SchulhofLite ();
	if (!_stricmp (Room->strName, "hm"))
		return Rooms.HM ();
	if (!_stricmp (Room->strName, "klo"))
		return Rooms.Klo ();
	if (!_stricmp (Room->strName, "sekretar"))
		return Rooms.Sekretar ();
	
	return false;
}

void MRoomMgr::DialogCmd (LPCSTR strCmd, int iArg)
{
	if (!_stricmp (strCmd, "fix"))
	{
		FILE *fpSetup = fopen ("config.blt", "wb");
		fputc ((char)iArg, fpSetup);
		fclose (fpSetup);

		if (iArg <= 1)
		{
			App->bFix = (iArg == 1);
			
			App->CurRoom->Leave (false);
			App->CurActor->Unload ();
			App->CurActor->Load ();
			App->CurRoom->Enter (false);
		}
		return;
	}
	else if (!_stricmp (strCmd, "exit"))
	{
		PostQuitMessage (1);
		return;
	}
	else if (!_stricmp (strCmd, "load"))
	{
		App->Load (iArg);
		return;
	}
	else if (!_stricmp (strCmd, "save"))
	{
		App->Save (iArg);
		return;
	}
	else if (!_stricmp (strCmd, "textspeed"))
	{
		App->timeTextRemain = iArg;
		return;
	}
	else if (!_stricmp (strCmd, "macass"))
	{
		int dirOld = App->CurRoom->getActor ("aMac")->dirCur;
		App->CurRoom->getActor ("aMac")->dirCur = 1;

		DWORD timeWait = timeGetTime () + 2000;
		while (timeWait > timeGetTime()) 
			App->Render ();

		App->CurRoom->getActor ("aMac")->dirCur = dirOld;
	}	
	else if (!_stricmp (strCmd, "hangup"))
	{
		App->CurRoom->getFrame ("fDealerHandy")->bVisible = true;
	}	
	else if (!_stricmp (strCmd, "cd"))
	{
		App->Events (CM_CDNOTIFY, 0, 0);
	}	
	else if (!_stricmp (strCmd, "Deal"))
	{
		App->CurActor->WalkTo (App->CurRoom->getObject ("oDealer")->posWalk, App->CurRoom->getObject ("oDealer")->dirWalk, 20);
	}
	else if (!_stricmp (strCmd, "ZettelTimer"))
	{
		timeZettel = timeGetTime () + 180000;
		App->Registry->Add ("StefanosWeg");
	}
	else if (!_stricmp (strCmd, "GiveKau"))
	{
		App->CmdBar->ItemStore.GetItem ("iKaugummis")->bVisible = true;
	}
	else if (!_stricmp (strCmd, "GiveWeck"))
	{
		App->CmdBar->ItemStore.GetItem ("iWeck")->bVisible = true;
	}
	else if (!_stricmp (strCmd, "GiveTape"))
	{
		App->CmdBar->ItemStore.GetItem ("iKassette")->bVisible = true;
	}
	else if (!_stricmp (strCmd, "GiveWater"))
	{
		App->CmdBar->ItemStore.GetItem ("iWasser")->bVisible = true;
	}
	else if (!_stricmp (strCmd, "kaffeecode"))
	{
		iCombo[2] = iCombo[1];
		iCombo[1] = iCombo[0];
		iCombo[0] = App->Registry->getData ("Kaffee");
		LogInt ("comb ", iCombo[0]);
		// combo check
		if (iCombo[0] == 3 && iCombo[1] == 2 && iCombo[2] == 3)
		// call event
		{
			char strID[4] = "#1";
			LPCSTR strArg[2] = { strID, NULL };
			DoCmd (App->CurRoom, CMD_EVENT, strArg);
		}
	}

	else if (!_stricmp (strCmd, "randomitem"))
	{
		int iItem;

		// reg entry
		if (!App->Registry->Exists ("randomitem"))
		{
			iItem = 0;
			App->Registry->Add ("randomitem", 1);
		}
		else
		{
			iItem = App->Registry->getData ("randomitem");
			App->Registry->setData ("randomitem", iItem + 1);
		}
		// items
		switch (iItem)
		{
		case 0:
			App->CmdBar->ItemStore.GetItem ("iKuerbis")->bVisible = true;
			break;
		case 1:
			App->CmdBar->ItemStore.GetItem ("iSchwein")->bVisible = true;
			break;
		case 2:
			App->CmdBar->ItemStore.GetItem ("iGlockenbaer")->bVisible = true;
			break;
		case 3:
			App->CmdBar->ItemStore.GetItem ("iZwerge")->bVisible = true;
			break;
		case 4:
			App->CmdBar->ItemStore.GetItem ("iDrache")->bVisible = true;
			break;
		case 5:
			App->CmdBar->ItemStore.GetItem ("iKristall")->bVisible = true;
			break;
		}
		
		if (iItem <= 5)
			App->CurActor->Text->Add ("(Hmmm... wollte ich das wirklich ?)");
		else
			App->CurActor->Text->Add ("STOP ! JETZT REICHTS !#Ich kann nicht noch mehr Mll gebrauchen !");
	}
}

void MRoomMgr::SaveGame (FILE *fileSave)
{
	DWORD timeSave;
	fwrite (strOldRoom, 20, 1, fileSave);
	fwrite (iCombo, 3, sizeof(int), fileSave);
	WriteData (fileSave, iOldTuer);
	
	timeSave = timeGong - timeGetTime ();
	WriteData (fileSave, timeSave);
	timeSave = timeGlatt - timeGetTime ();
	WriteData (fileSave, timeSave);
	timeSave = timeZettel - timeGetTime ();
	WriteData (fileSave, timeSave);
	timeSave = timeDaimon - timeGetTime ();
	WriteData (fileSave, timeSave);
	timeSave = timeFallert - timeGetTime ();
	WriteData (fileSave, timeSave);
	timeSave = timeTuer - timeGetTime ();
	WriteData (fileSave, timeSave);
	timeSave = timePush - timeGetTime ();
	WriteData (fileSave, timeSave);
}

void MRoomMgr::LoadGame (FILE *fileLoad)
{
	DWORD timeLoad;
	fread (strOldRoom, 20, 1, fileLoad);
	fread (iCombo, 3, sizeof(int), fileLoad);
	ReadData (fileLoad, iOldTuer);
	
	ReadData (fileLoad, timeLoad);
	timeGong = timeGetTime () + timeLoad;
	ReadData (fileLoad, timeLoad);
	timeGlatt = timeGetTime () + timeLoad;
	ReadData (fileLoad, timeLoad);
	timeZettel = timeGetTime () + timeLoad;
	ReadData (fileLoad, timeLoad);
	timeDaimon = timeGetTime () + timeLoad;
	ReadData (fileLoad, timeLoad);
	timeFallert = timeGetTime () + timeLoad;
	ReadData (fileLoad, timeLoad);
	timeTuer = timeGetTime () + timeLoad;
	ReadData (fileLoad, timeLoad);
	timePush = timeGetTime () + timeLoad;
}